<?php

/**
 * res_saldos_aportes actions.
 *
 * @package    nomina
 * @subpackage res_saldos_aportes
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class res_saldos_aportesActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.CODIGO, tab0.codigo_ss, tab0.CODIGO_fondo, tab0.codigo_concep, tab0.NUM_DOC ';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];
            $periodo = $request['id_periodo'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //Clase Fondo
            if (isset($request['id_clase_fondo'])) {
                $whereClaseFondo = " AND tab0.id_clase_fondo = " . $request['id_clase_fondo'];
            } else {
                $whereClaseFondo = ' ';
            }
            //MaestroFondos
            if (isset($request['id_mae_fondos'])) {
                $whereMaestroFondos = " AND tab0.id_mae_fondos = " . $request['id_mae_fondos'];
            } else {
                $whereMaestroFondos = ' ';
            }
            //tipo concepto
            if (isset($request['id_tipo_concepto'])) {
                $whereTipoConcepto = " AND tab0.id_tipo_concepto = " . $request['id_tipo_concepto'];
            } else {
                $whereTipoConcepto = ' ';
            }
            //concepto nomina
            if (isset($request['id_concep_nomina'])) {
                $whereConcepto = " AND tab0.id_concep_nomina = " . $request['id_concep_nomina'];
            } else {
                $whereConcepto = ' ';
            }


            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

SELECT tab0.* FROM (

    SELECT 

    tab0.*,
    per.ID_ANHOS,
    per.ID_MESES,
    per.ID_TIPO_PERIODO,
    per.PERIODO,
    dat.NOMBRE_APELLIDO,
    dat.NOMBRE_COMPLETO,

    clafon.CODIGO,
    clafon.DESCRIPCION,
    clafon.CODIGO || ' - ' || clafon.DESCRIPCION as clase_fondo,

    maefon.codigo AS CODIGO_fondo,
    maefon.razon_social AS FONDO,
    maefon.codigo || ' - ' || maefon.razon_social as maestro_fondos,

    concep.codigo as codigo_concep,
    concep.descripcion as descripcion_concep,
    concep.codigo || ' - ' || concep.descripcion as concepto_nomina,

    concep.ID_TIPO_CONCEPTO,
    descss.codigo as codigo_ss,
    descss.descripcion as descripcion_ss,
    descss.codigo || ' - ' || descss.descripcion as descuento_ss

    FROM NO_SALDOS_APORTE tab0

    left join NO_PERIODO_V per
    on tab0.ID_PERIODO = per.ID_PERIODO

    left join NO_DATOS_FUNCIONARIO_V dat
    on dat.ID_TIPO_DOC = tab0.ID_TIPO_DOC
    and dat.NUM_DOC = tab0.NUM_DOC

    join NO_CLASE_FONDO clafon
    on tab0.ID_CLASE_FONDO = clafon.ID_CLASE_FONDO

    left join no_mae_fondos maefon
    on tab0.ID_MAE_FONDOS = maefon.ID_MAE_FONDOS

    left JOIN NO_CONCEPTOS_V concep 
    ON tab0.id_concep_nomina = concep.id_concep_nomina

    left join no_descuento_ss descss
    on descss.id_descuento_ss = tab0.id_descuento_ss

    where tab0.id_periodo = $periodo_filtro
    $whereClaseFondo $whereMaestroFondos
    $whereFuncionarioTipoDoc $whereFuncionarioNumDoc 

)tab0
                    
where
1 = 1                    
$whereTipoConcepto $whereConcepto 
        
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

SELECT tab0.* FROM (
                    
    SELECT 

    tab0.*,
    per.ID_ANHOS,
    per.ID_MESES,
    per.ID_TIPO_PERIODO,
    per.PERIODO,
    dat.NOMBRE_APELLIDO,
    dat.NOMBRE_COMPLETO,

    clafon.CODIGO,
    clafon.DESCRIPCION,
    clafon.CODIGO || ' - ' || clafon.DESCRIPCION as clase_fondo,

    maefon.codigo AS CODIGO_fondo,
    maefon.razon_social AS FONDO,
    maefon.codigo || ' - ' || maefon.razon_social as maestro_fondos,

    concep.codigo as codigo_concep,
    concep.descripcion as descripcion_concep,
    concep.codigo || ' - ' || concep.descripcion as concepto_nomina,

    concep.ID_TIPO_CONCEPTO,
    descss.codigo as codigo_ss,
    descss.descripcion as descripcion_ss,
    descss.codigo || ' - ' || descss.descripcion as descuento_ss

    FROM NO_SALDOS_APORTE tab0

    left join NO_PERIODO_V per
    on tab0.ID_PERIODO = per.ID_PERIODO

    left join NO_DATOS_FUNCIONARIO_V dat
    on dat.ID_TIPO_DOC = tab0.ID_TIPO_DOC
    and dat.NUM_DOC = tab0.NUM_DOC

    join NO_CLASE_FONDO clafon
    on tab0.ID_CLASE_FONDO = clafon.ID_CLASE_FONDO

    left join no_mae_fondos maefon
    on tab0.ID_MAE_FONDOS = maefon.ID_MAE_FONDOS

    left JOIN NO_CONCEPTOS_V concep 
    ON tab0.id_concep_nomina = concep.id_concep_nomina

    left join no_descuento_ss descss
    on descss.id_descuento_ss = tab0.id_descuento_ss

    where tab0.id_periodo = $periodo_filtro
    $whereClaseFondo $whereMaestroFondos
    $whereFuncionarioTipoDoc $whereFuncionarioNumDoc 

)tab0
                    
where
1 = 1                    
$whereTipoConcepto $whereConcepto 
    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[res_saldos_aportes] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("[res_saldos_aportes] ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Metodo para sumar 
     *
     * @param sfWebRequest $request
     */
    public function executeSum(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.CODIGO, tab0.codigo_ss, tab0.CODIGO_fondo, tab0.codigo_concep, tab0.NUM_DOC ';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];
            $periodo = $request['id_periodo'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //Clase Fondo
            if (isset($request['id_clase_fondo'])) {
                $whereClaseFondo = " AND tab0.id_clase_fondo = " . $request['id_clase_fondo'];
            } else {
                $whereClaseFondo = ' ';
            }
            //MaestroFondos
            if (isset($request['id_mae_fondos'])) {
                $whereMaestroFondos = " AND tab0.id_mae_fondos = " . $request['id_mae_fondos'];
            } else {
                $whereMaestroFondos = ' ';
            }
            //tipo concepto
            if (isset($request['id_tipo_concepto'])) {
                $whereTipoConcepto = " AND tab0.id_tipo_concepto = " . $request['id_tipo_concepto'];
            } else {
                $whereTipoConcepto = ' ';
            }
            //concepto nomina
            if (isset($request['id_concep_nomina'])) {
                $whereConcepto = " AND tab0.id_concep_nomina = " . $request['id_concep_nomina'];
            } else {
                $whereConcepto = ' ';
            }

            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT

'Total: ' || count(*) as clase_fondo,
SUM(saldo_anterior)  as saldo_anterior,
SUM(valor_nomina)  as valor_nomina,
SUM(valor_aporte_func)  as valor_aporte_func,
SUM(valor_aporte_patrono)  as valor_aporte_patrono,
SUM(saldo_actual)  as saldo_actual

FROM (  

SELECT tab0.* FROM (
                    
    SELECT 

    tab0.*,
    per.ID_ANHOS,
    per.ID_MESES,
    per.ID_TIPO_PERIODO,
    per.PERIODO,
    dat.NOMBRE_APELLIDO,
    dat.NOMBRE_COMPLETO,

    clafon.CODIGO,
    clafon.DESCRIPCION,
    clafon.CODIGO || ' - ' || clafon.DESCRIPCION as clase_fondo,

    maefon.codigo AS CODIGO_fondo,
    maefon.razon_social AS FONDO,
    maefon.codigo || ' - ' || maefon.razon_social as maestro_fondos,

    concep.codigo as codigo_concep,
    concep.descripcion as descripcion_concep,
    concep.codigo || ' - ' || concep.descripcion as concepto_nomina,

    concep.ID_TIPO_CONCEPTO,
    descss.codigo as codigo_ss,
    descss.descripcion as descripcion_ss,
    descss.codigo || ' - ' || descss.descripcion as descuento_ss

    FROM NO_SALDOS_APORTE tab0

    left join NO_PERIODO_V per
    on tab0.ID_PERIODO = per.ID_PERIODO

    left join NO_DATOS_FUNCIONARIO_V dat
    on dat.ID_TIPO_DOC = tab0.ID_TIPO_DOC
    and dat.NUM_DOC = tab0.NUM_DOC

    join NO_CLASE_FONDO clafon
    on tab0.ID_CLASE_FONDO = clafon.ID_CLASE_FONDO

    left join no_mae_fondos maefon
    on tab0.ID_MAE_FONDOS = maefon.ID_MAE_FONDOS

    left JOIN NO_CONCEPTOS_V concep 
    ON tab0.id_concep_nomina = concep.id_concep_nomina

    left join no_descuento_ss descss
    on descss.id_descuento_ss = tab0.id_descuento_ss

    where tab0.id_periodo = $periodo_filtro
    $whereClaseFondo $whereMaestroFondos
    $whereFuncionarioTipoDoc $whereFuncionarioNumDoc 

)tab0
                    
where
1 = 1                    
$whereTipoConcepto $whereConcepto 

)
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);

            $this->totalRows = count($resultado);
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("[res_saldos_aportes] ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
